<i18n>
{
  "fr": {
    "title-1": "Ajouter un matériel informatique",
    "title-2": "Modifier un matériel informatique",
    "info-1": "Sélectionnez le type d'équipement numérique (PC fixe, portable, écran, serveur, etc.) ainsi que son modèle si connu.",
    "field-1": "Type",
    "field-2": "Modèle",
    "field-3": "Quantité"
  },
  "en": {
    "title-1": "Add a digital device",
    "title-2": "Update a digital device",
    "info-1": "Select the type of digital device (desktop, laptop, monitor, server, etc.) and the model when available",
    "field-1": "Type",
    "field-2": "Model",
    "field-3": "Quantity"
  }
}
</i18n>

<template>
  <b-modal
    :active.sync="displayModal"
    has-modal-card
    :can-cancel="['escape', 'x']"
  >
    <div class="dialog" style="width: 800px; height: auto">
    <div class="modal-card" style="max-width: 100%">
      <form @submit.prevent="validateBeforeSubmit">
        <header class="modal-card-head">
          <p class="modal-card-title">{{ modalTitle }}</p>
        </header>
        <section class="modal-card-body">
          <div class="box-blue">
            {{ $t('info-1') }}
          </div>
          <br />
          <div class="columns">
            <div class="column">
              <b-field :label="$t('field-1')">
                <ecodiag-select-type
                  expanded
                  v-model="citem.type"
                  size=""
                  msg="...">
                </ecodiag-select-type>
              </b-field>
            </div>
            <div class="column">
              <b-field :label="$t('field-2')">
                <ecodiag-select-model
                  expanded
                  v-model="citem.model"
                  :item_type="citem.type"
                  always-visible
                  size="">
                </ecodiag-select-model>
              </b-field>
            </div>
            <div class="column">
              <b-field :label="$t('field-3')">
                <input class="input" v-model.number="citem.nb" type="number" min="0" max="99999" step="1" />
              </b-field>
            </div>
          </div>
          <br />
          </section>
          <footer class="modal-card-foot">
            <b-button
              class="button"
              @click="$emit('close')"
              icon-left="close"
            >
              {{ $t('cancel') }}
            </b-button>
            <button
              v-show="modeCreation"
              :disabled="!isValid"
              type="submit"
              class="button is-primary"
            >
              <b-icon icon="plus" />
              <span> {{ $t('add') }} </span>
            </button>
            <button
              v-show="!modeCreation"
              type="submit"
              class="button is-primary"
            >
              <b-icon icon="refresh" />
              <span> {{ $t('update') }} </span>
            </button>
        </footer>
      </form>
    </div>
    </div>
  </b-modal>
</template>

<script>

/* This modal can be used for creating or editing a numeric item,
   though currently it is used for creation only. */

/* eslint-disable camelcase */

import { devices } from '@/ext/ecodiag/devices'
import { device_utils } from '@/ext/ecodiag/device_utils'

export default {
  name: 'ComputerDeviceModal',
  props: {
    displayModal: {
      type: Boolean,
      default: false
    },
    item: {
      type: Object,
      default: function () {
        return {}
      }
    },
    modeCreation: {
      type: Boolean,
      default: false
    }
  },
  mixins: [device_utils],
  components: {
    'ecodiag-select-type': () => import('@/ext/ecodiag/components/type_selector.vue'),
    'ecodiag-select-model': () => import('@/ext/ecodiag/components/model_selector.vue')
  },
  data () {
    return {
      citem: this.item
    }
  },
  computed: {
    isValid () {
      return this.citem && this.citem.type in devices && this.citem.nb > 0
    },
    modalTitle () {
      return this.modeCreation ? this.$t('title-1') : this.$t('title-2')
    }
  },
  methods: {
    validateBeforeSubmit () {
      this.$emit('validated', this.citem)
    }
  }
}
</script>
